diff --git a/jstests/multiVersion/config_chunks_tags_upgrade_downgrade_cluster.js b/jstests/multiVersion/config_chunks_tags_upgrade_downgrade_cluster.js
index 0e81aca3c6..200b43818d 100644
--- a/jstests/multiVersion/config_chunks_tags_upgrade_downgrade_cluster.js
+++ b/jstests/multiVersion/config_chunks_tags_upgrade_downgrade_cluster.js
@@ -46,36 +46,30 @@ assert.commandWorked(st.s.adminCommand({enableSharding: dbName}));
 st.ensurePrimaryShard(dbName, st.shard0.shardName);
 
 // Set up sharded collections for targeted chunk and zone operation testing.
+jsTestLog("XXX Setting up collections 1.");
 setUpCollectionForChunksTesting(st, chunkNs);
 setUpCollectionForZoneTesting(st, zoneNs);
 
-// Set up another sharded collection on a different database to verify chunks and zones are updated
-// for every sharded collection.
-setUpExtraShardedCollections(st, "extra_db" /* dbName */);
-
 // Set up collections with the same number of chunks and zones as the batch limit for the
 // transactions used to modify chunks and zones documents and with more than the limit to verify the
 // batching logic in both cases.
-const txnBatchSize = 100;
-setUpCollectionWithManyChunksAndZones(
-    st, dbName + ".many_at_batch_size", txnBatchSize /* numChunks */, txnBatchSize /* numZones */);
+const txnBatchSize = 2;
+jsTestLog("XXX Setting up collections 2.");
 setUpCollectionWithManyChunksAndZones(st,
                                       dbName + ".many_over_batch_size",
-                                      txnBatchSize + 5 /* numChunks */,
-                                      txnBatchSize + 5 /* numZones */);
+                                      txnBatchSize + 2 /* numChunks */,
+                                      txnBatchSize + 2 /* numZones */);
 
 //
 // Upgrade back to the latest version.
 //
-
-verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: false});
-
-jsTestLog("Upgrading config servers.");
+jsTestLog("XXX Upgrading config servers.");
 st.upgradeCluster("latest", {upgradeConfigs: true, upgradeMongos: false, upgradeShards: false});
 
+jsTestLog("XXX verifying chunks.");
 verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: false});
 
-jsTestLog("Upgrading shard servers.");
+jsTestLog("XXX Upgrading shard servers.");
 st.upgradeCluster("latest", {upgradeConfigs: false, upgradeMongos: false, upgradeShards: true});
 
 // Manually moving a chunk will use the config server's replica set monitor to target the primary of
@@ -83,52 +77,14 @@ st.upgradeCluster("latest", {upgradeConfigs: false, upgradeMongos: false, upgrad
 // operations through the config server that will use the same RSM so it picks up the new primary.
 waitForConfigServerShardRSMRetarget(st);
 
+jsTestLog("XXX verifying chunks.");
 verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: false});
 
-jsTestLog("Upgrading mongos servers.");
-st.upgradeCluster("latest", {upgradeConfigs: false, upgradeMongos: true, upgradeShards: false});
-checkFCV(st.configRS.getPrimary().getDB("admin"), lastStableFCV);
-
-verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: false});
-
-jsTestLog("Upgrade feature compatibility version to latest");
-assert.commandWorked(st.s.getDB("admin").runCommand({setFeatureCompatibilityVersion: latestFCV}));
-checkFCV(st.configRS.getPrimary().getDB("admin"), latestFCV);
-
-verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: true});
-
-//
-// Downgrade back to the last stable version.
-//
-
-jsTestLog("Downgrade feature compatibility version to last stable");
-assert.commandWorked(st.s.adminCommand({setFeatureCompatibilityVersion: lastStableFCV}));
-checkFCV(st.configRS.getPrimary().getDB("admin"), lastStableFCV);
-
-verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: false});
-
-jsTestLog("Downgrading mongos servers.");
-st.upgradeCluster("last-stable",
-                  {upgradeConfigs: false, upgradeMongos: true, upgradeShards: false});
-
-verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: false});
-
-jsTestLog("Downgrading shard servers.");
+jsTestLog("XXX Downgrading shard servers.");
 st.upgradeCluster("last-stable",
                   {upgradeConfigs: false, upgradeMongos: false, upgradeShards: true});
 
-// Manually moving a chunk will use the config server's replica set monitor to target the primary of
-// the source shard. After upgrading the shard servers above, this RSM may be stale, so run
-// operations through the config server that will use the same RSM so it picks up the new primary.
-waitForConfigServerShardRSMRetarget(st);
-
-verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: false});
-
-jsTestLog("Downgrading config servers.");
-st.upgradeCluster("last-stable",
-                  {upgradeConfigs: true, upgradeMongos: false, upgradeShards: false});
-checkFCV(st.configRS.getPrimary().getDB("admin"), lastStableFCV);
-
+jsTestLog("XXX Verifying after downgrading shard.");
 verifyChunksAndTags(st, dbName, chunkNs, zoneNs, {expectNewFormat: false});
 
 st.stop();